-- Design: 4-bit adder
-- Structural description of a 4-bit adder. 
LIBRARY IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- DECLARATION of design entity.
entity fourbit_adder is
  port( 
    a, b : in STD_LOGIC_VECTOR(3 downto 0);
    s    : out STD_LOGIC_VECTOR(3 downto 0);
    cout : out STD_LOGIC
  );
end fourbit_adder;


-- DESCRIPTION of architecture.
architecture MY_STRUCTURAL of fourbit_adder is

-- will use four 1-bit adders, chained together.
component full_adder
  port(a, b, cin: in std_logic;
  sum, cout: out std_logic);
end component;

signal c0, c1, c2, c3 : STD_LOGIC;

begin
c0 <= '0';
FA0: full_adder port map (a=>a(0), b=>b(0), cin=>c0, sum=>s(0), cout=>c1);
FA1: full_adder port map (a=>a(1), b=>b(1), cin=>c1, sum=>s(1), cout=>c2);
FA2: full_adder port map (a=>a(2), b=>b(2), cin=>c2, sum=>s(2), cout=>c3);
FA3: full_adder port map (a=>a(3), b=>b(3), cin=>c3, sum=>s(3), cout=>cout);
end MY_STRUCTURAL;